# dmd.templateparamsem

Semantic analysis of template parameters.

#### Authors

Walter Bright

#### License

Boost License 1.0

Source: templateparamsem.d

Documentation: https://dlang.org/phobos/dmd_templateparamsem.html

Coverage: https://codecov.io/gh/dlang/dmd/src/master/src/dmd/templateparamsem.d

- `tpsemantic`

  #### Declaration

  `bool `tpsemantic`(TemplateParameter `tp`, Scope* `sc`, TemplateParameters* `parameters`);`

  Performs semantic on TemplateParameter AST nodes.

  #### Parameters

  `TemplateParameter `tp`` | element of ``parameters`` to be semantically analyzed
  `Scope* `sc`` | context
  `TemplateParameters* `parameters`` | array of `TemplateParameters` supplied to the `TemplateDeclaration`

  #### Return Value

  `true` if no errors

- `aliasParameterSemantic`

  #### Declaration

  `RootObject `aliasParameterSemantic`(Loc `loc`, Scope* `sc`, RootObject `o`, TemplateParameters* `parameters`);`

  Support function for performing semantic analysis on `TemplateAliasParameter`.

  #### Parameters

  `Loc `loc`` | location (for error messages)
  `Scope* `sc`` | context
  `RootObject `o`` | object to run semantic() on, the `TemplateAliasParameter`s `specAlias` or `defaultAlias`
  `TemplateParameters* `parameters`` | array of `TemplateParameters` supplied to the `TemplateDeclaration`

  #### Return Value

  object resulting from running `semantic` on ``o``